# -*- coding: utf-8 -*-

from django_logit import logit
from django_response import response
from TimeConvert import TimeConvert as tc

from statistic.models import (DistributorSaleStatisticInfo, ModelSaleStatisticInfo, RegisterStatisticInfo,
                              SaleStatisticInfo)


@logit
def tj_data(request):
    ymd = tc.local_string(format='%Y%m%d')

    # 注册用户统计 & 今日注册用户
    try:
        register_num = RegisterStatisticInfo.objects.get(ymd=ymd).num
    except RegisterStatisticInfo.DoesNotExist:
        register_num = 0

    # 注册用户数趋势
    register_trends = RegisterStatisticInfo.objects.filter(status=True).order_by('-pk')[:30]
    register_trends = [r.data for r in register_trends]

    # 销量统计 & 今日销量
    try:
        sale_num = SaleStatisticInfo.objects.get(ymd=ymd).num
    except RegisterStatisticInfo.DoesNotExist:
        sale_num = 0

    # 商品销量趋势
    sale_trends = SaleStatisticInfo.objects.filter(status=True).order_by('-pk')[:30]
    sale_trends = [s.data for s in sale_trends]

    # 型号销量统计 & 热销商品榜
    model_sales = ModelSaleStatisticInfo.objects.filter(status=True).order_by('-num')[:3]
    model_sales = [m.data for m in model_sales]

    # 经销商销量统计 & 经销商榜
    distributor_sales = DistributorSaleStatisticInfo.objects.filter(status=True).order_by('-num')[:3]
    distributor_sales = [d.data for d in distributor_sales]

    return response(200, 'Get TJ Data Success', u'获取统计数据成功', {
        'register_num': register_num,
        'register_trends': register_trends,
        'sale_num': sale_num,
        'sale_trends': sale_trends,
        'model_sales': model_sales,
        'distributor_sales': distributor_sales,
    })
